﻿#include <iostream>
#include <vector>
#include <algorithm>
#include "histogram.h"


using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    cerr << "Enter bin_count: ";
    cin >> in.bin_count;
    sort(begin(in.numbers), end(in.numbers));
    in.numbers.erase(unique(begin(in.numbers), end(in.numbers)), end(in.numbers));
    number_count = in.numbers.size();
    return in;
}

void
show_histogram_text(const vector<size_t>& bins, size_t& bin_count) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t max_count = 0;
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i] > max_count) {
            max_count = bins[i];
        }
    }
    double kof = double(MAX_ASTERISK) / max_count;
    if (kof > 1) {
        kof = 1;
    }
    for (size_t bin : bins) {
        if (bin < 100) {
            cout << " ";
        }
        if (bin < 10) {
            cout << " ";
        }
        cout << bin << "|";
        for (size_t i = 0; i < size_t(bin * kof); i++) {
            cout << "*";
        }
        cout << endl;
    }
}

int main() {
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);
}
       
       
    